
#ifndef MLX_SN_SX_CPLD_H__
#define MLX_SN_SX_CPLD_H__

#define CPLD_REG_VERSION1_OFFSET                    (0x00)

#define CPLD_REG_VERSION2_OFFSET                    (0x01)

#define CPLD_REG_VERSION3_OFFSET                    (0x02)

#define CPLD_REG_FAN_STATUS_OFFSET                  (0x88)
  #define CPLD_FAN1_STATUS                          (1 << 0)
  #define CPLD_FAN2_STATUS                          (1 << 1)
  #define CPLD_FAN3_STATUS                          (1 << 2)
  #define CPLD_FAN4_STATUS                          (1 << 3)

#define CPLD_REG_FAN_MASK_OFFSET                    (0x8a)

#define CPLD_REG_PSU_SYS_LED                        (0x20)
  #define CPLD_LED_MASK                             (0x0f)
  #define CPLD_PSU_LED_SHIFT                        (4)
  #define CPLD_STATUS_LED_SHIFT                     (0)

#define CPLD_REG_FAN1_FAN2_LED                      (0x21)
  #define CPLD_FAN2_LED_SHIFT                       (4)
  #define CPLD_FAN1_LED_SHIFT                       (0)

#define CPLD_REG_FAN3_FAN4_LED                      (0x22)
  #define CPLD_FAN4_LED_SHIFT                       (4)
  #define CPLD_FAN3_LED_SHIFT                       (0)

#define CPLD_REG_2100_PSU_LED                       (0x23)
  #define CPLD_2100_PSU1_LED_SHIFT                  (0)
  #define CPLD_2100_PSU2_LED_SHIFT                  (4)

#define LED_IS_OFF                                  (0x00)
#define LED_RED_STATIC_ON                           (0x05)
#define LED_RED_BLINK_3HZ                           (0x06)
#define LED_RED_BLINK_6HZ                           (0x07)
#define LED_GREEN_STATIC_ON                         (0x0D)
#define LED_GREEN_BLINK_3HZ                         (0x0E)
#define LED_GREEN_BLINK_6HZ                         (0x0F)

#define CPLD_REG_PSU_PRESENT_OFFSET                 (0x58)
  #define CPLD_PSU1_PRESENT                         (1 << 0)
  #define CPLD_PSU2_PRESENT                         (1 << 1)

#define CPLD_REG_PSU_STATUS_OFFSET                  (0x64)
  #define CPLD_PSU1_OK                              (1 << 0)
  #define CPLD_PSU2_OK                              (1 << 1)

#define CPLD_REG_RESET_CAUSE_OFFSET                 (0x1d)
  #define CPLD_RESET_CAUSE_CLEAN                    (0x00)
  #define CPLD_RESET_CAUSE_LONG_PB                  (0x01)
  #define CPLD_RESET_CAUSE_SHORT_PB                 (0x02)
  #define CPLD_RESET_CAUSE_AUXPWR_OR_FU             (0x03)
  #define CPLD_RESET_CAUSE_POWER_FAIL               (0x08)
  #define CPLD_RESET_CAUSE_SW_RST                   (0x10)
  #define CPLD_RESET_CAUSE_FW_RST                   (0x20)
  #define CPLD_RESET_CAUSE_WATCHDOG                 (0x40)
  #define CPLD_RESET_CAUSE_THERMAL                  (0x80)

#endif /* MLX_SN_SX_CPLD_H__ */
